	include "tios.h"
	include "flib.h"
	include "mxmlib.h"
;	include "hufflib.h"
;	include "gray4lib.h"
	include "macros.h"
	xdef _main
	xdef _comment

readkeyon	MACRO
	st.w intflag
	ENDM

readkeyoff	MACRO
	clr.w intflag
	ENDM

; To avoid the ON-Key "Cheat" we use AutoInt 6 for a faster game
autoint6:
	rte

; Our own AutoInt 1
autoint1:
	add.w #1,vbl
	and.w #3,vbl
	tst.w intflag
	beq _rret
	move.l oldint1,-(a7)
	rts
_rret:
	rte

;
; This input routine is from MINE.ASM
;

input:
	movem.l	d0-d4/a0-a2,-(sp)
	movem.l	d0-d1/a0,-(sp)
	readkeyon
	SetFont	d4
	movem.l	(sp)+,d0-d1/a0
	move.w  #10,d0
_iql:
	dbra.w  d0,_iql
	move.l	a6,a2
	moveq	#0,d4

	bra.s	\skip1
\loop1	jsr	flib::idle_loop
	cmp.w	#13,d0			; Enter ?
	beq.s	\enter
	cmp.w	#257,d0			; Backspace ?
	bne.s	\skip2
	tst.w	d4
	beq.s	\loop1
	subq.l	#1,a2
	subq.w	#1,d4
	bra.s	\skip1
\skip2	cmp.w	d1,d4			; Maximum number of characters read ?
	bcc.s	\loop1
	cmp.w	#255,d0			; Valid character ?
	bhi.s	\loop1
	addq.w	#1,d4
	move.b	d0,(a2)+
\skip1	move.b	#95,(a2)
	move.b	#32,1(a2)
	clr.b	2(a2)
	bsr	input_
	bra.s	\loop1

\enter	move.b	#32,(a2)
	clr.b	1(a2)
	bsr	input_
	clr.b	(a2)
	move.l	a6,a2
\loop2	move.b	(a2)+,(a0)+
	bne.s	\loop2
	movem.l	(sp)+,d0-d4/a0-a2
	rts

input_:
	movem.l	d1-d2/a0,-(sp)
	move.w	#4,-(sp)
	move.l	a6,-(sp)
	move.w	d3,-(sp)
	move.w	d2,-(sp)
	jsr	tios::DrawStrXY
	lea	10(sp),sp
	movem.l	(sp)+,d1-d2/a0
	rts


putsprite:
; Puts a sprite onto the screen
; In 	A0 	Pointer to the sprite
;	D0.W 	X coordinate (0 - 239)
;	D1.W	Y coordinate
; Out 	Nothing
; We used SPRITES.ASM from David Ellsworth and modified it for a little bit

	movem.l d0-d6/a0-a4,-(a7)
	move.w d1,d2
	lsl.w #4,d1
	sub.w d2,d1
	lsl.w #1,d1
	ext.l d1
	move.l d1,a1
	move.w d0,d2
	and.w #$F,d2
	and.w #$FFF0,d0
	asr.w #3,d0
	ext.l d0
	adda.l d0,a1	
	adda.l #LCD_MEM,a1
	tst.w d2
	beq QPut
	cmp.w #8,d2
	blt RShift
LShift:
	sub.w #16,d2
	neg.w d2
	move.w #15,d3
LLoop:
	clr.l d1
	move.w (a0)+,d1
	lsl.l d2,d1
	or.l d1,(a1)
	lea 30(a1),a1
	dbra.w d3,LLoop
	movem.l (a7)+,d0-d6/a0-a4
	rts
RShift:
	move.w #15,d3
RLoop:
	clr.l d1
	move.w (a0)+,d1
	swap d1
	lsr.l d2,d1
	or.l d1,(a1)
	lea 30(a1),a1
	dbra.w d3,RLoop
	movem.l (a7)+,d0-d6/a0-a4
	rts
QPut:
	move.w #15,d3
QLoop:
	move.w (a0)+,d2	
	or.w d2,(a1)
	lea 30(a1),a1
	dbra.w d3,QLoop
	movem.l (a7)+,d0-d6/a0-a4
	rts


showhiscore:
; Showes the HiScore
	movem.l d0-d6/a0-a4,-(a7)
	jsr flib::zap_screen
	SetFont #1
	WriteStr #1,#11,#4,tchi
	SetFont #2
	move.w #4,d0
	lea hiscore(PC),a3
showhiscoreloop:
	move.w 8(a3),d6
	movem.l d0-d4/a0-a3,-(a7)
	move.w d6,-(sp)
	move.l a3,-(sp)
	pea formathiscore(PC)
	pea output(PC)
	jsr tios::sprintf
	add.l #14,sp
	movem.l (a7)+,d0-d4/a0-a3
	move.w #5,d3
	sub.w d0,d3
	mulu.w #12,d3
	add.w #15,d3
	movem.l d0-d4/a0-a3,-(a7)
	WriteStr #1,d3,#4,output
	movem.l (a7)+,d0-d4/a0-a3
	lea 10(a3),a3
	dbra.w d0,showhiscoreloop
	SetFont #1
	WriteStr #1,#100,#4,pressakey
	SetFont #2
	readkeyon
	jsr flib::idle_loop
	movem.l (a7)+,d0-d6/a0-a4
	rts

scanhiscore:
; Scans the Hiscore if the player has got a new HiScore
; In	D1	Points
; Out	Nothing
	movem.l d0-d5/a0-a4,-(a7)
	lea hiscore(PC),a1
	move.w d1,d5
	move.w #4,d2
	lea 8(a1),a1
higherpoints:
	move.w (a1),d3
	cmp.w d3,d1
	bhi _foundednew
	lea 10(a1),a1
	dbra.w d2,higherpoints
	movem.l (a7)+,d0-d5/a0-a4
	rts
_foundednew:
	movem.l d0-d6/a0-a4,-(a7)
	jsr flib::zap_screen
	SetFont #1
	WriteStr #1,#45,#4,rhiscore
	lea ppstr2(PC),a0
	lea ppstr(PC),a6
	move.w #7,d0
_clearoldinput:
	clr.b (a0)+
	clr.b (a6)+
	dbra.w d0,_clearoldinput
	lea ppstr2(PC),a0
	lea ppstr(PC),a6
	move.w #7,d1
	move.w #1,d4
	move.w #55,d3
	move.w #1,d2
	bsr input
	movem.l (a7)+,d0-d6/a0-a4
	lea ppstr(PC),a0
	lea -8(a1),a1
	move.l a1,a2
	move.l a1,a3
	lea hiscore(PC),a2
	adda.w #50,a2
	lea -10(a2),a3
	move.w d3,d4
	mulu.w #10,d2
_copyoldnames:
	move.b -(a3),-(a2)
	dbra.w d2,_copyoldnames
	move.b #7,d0
_copyname:
	move.b (a0)+,(a1)+
	dbra.w d0,_copyname
	move.w d5,(a1)
	movem.l (a7)+,d0-d5/a0-a4
	rts

put8sprite:
; In	D0,D1:	X,Y coordinates ( x = [ 0..28 ] )
;	A1	Pointer to the sprite
; 	A0	Buffer or #LCD_MEM
; Out	Nothing
	movem.l d0-d4/a0-a3,-(a7)
	mulu.w #30,d1
	add.w d0,d1
	adda.w d1,a0
	move.w #7,d0
copy8spr:
	move.w (a1)+,(a0)
	lea 30(a0),a0
	dbra.w d0,copy8spr
	movem.l (a7)+,d0-d4/a0-a3
	rts

getkey:
	movem.l d0-d2/a0,-(a7)
	move.w #9,d1
	move.w #$FFFE,d0
	lea keymatrix(PC),a0
_scanloop:
	move.w d0,($600018)
	nop
	nop
	nop
	nop
	move.b ($60001B),d2
	not.b d2
	move.b d2,(a0)+
	rol.w #1,d0
	dbra.w d1,_scanloop
	movem.l (a7)+,d0-d2/a0
	rts

createnewline:
	movem.l d0-d5/a0-a4,-(a7)
	move.l lpointer,a0
; We create this under the screen [ Line 130 ]
	lea 3870(a0),a0
	move.w #59,d0
_createwalls:
	move.l #$FFFFFFFF,(a0)+
	dbra.w d0,_createwalls
; Some holes [ at least 2 ]
	move.w #3,d0
	jsr flib::random
	add.w #1,d0
	move.w d0,d3
_create_holes:
	move.w #15,d0
	jsr flib::random
	lsl.w #1,d0
	lea nwall(PC),a1
	move.l lpointer,a0
	move.w #129,d1
	bsr put8sprite
	dbra.w d3,_create_holes
	movem.l (a7)+,d0-d5/a0-a4
	rts

shownumber:
; Shows a number
; In:	D4	-> X coordinate [ 0..28]
;	D5	-> Y coordinate
;	D6	-> Number
; Out:	Nothing
	movem.l d0-d4/a0-a4,-(a7)
	movem.l d4-d6,-(a7)
	move.w d6,-(sp)
	pea formatdec(PC)
	pea output(PC)
	jsr tios::sprintf
	add.l #10,sp
	movem.l (a7)+,d4-d6
	move.w d4,d0
	move.w d5,d4
	lea output(PC),a0
	lea number_sprites(PC),a4
_shownumberloop:
	clr.w d2
	move.b (a0)+,d2
	tst.w d2
	beq _end_show_number
	sub.w #48,d2
	lsl.w #3,d2
	move.l a4,a1
	adda.w d2,a1
	move.w d4,d1
	mulu.w #30,d1
	add.w d0,d1
	move.l lpointer,a2
	adda.w d1,a2
	move.w #7,d3
_CopyNumberLoop:
	move.b (a1)+,(a2)
	lea 30(a2),a2
	dbra.w d3,_CopyNumberLoop
	add.w #1,d0
	bra _shownumberloop
_end_show_number:
	movem.l (a7)+,d0-d4/a0-a4
	rts

scrollworldup:
	movem.l d0-d4/a0-a3,-(a7)
	move.l lpointer,a0
	move.l a0,a1
	adda.w #30,a1
	move.w #1064,d0
scrollup:
	move.l (a1)+,(a0)+
	dbra.w d0,scrollup
	move.l lpointer,a0
	adda.w #4170,a0
	move.w #14,d0
_clearoldline:
	clr.w (a0)+
	dbra.w d0,_clearoldline
	movem.l (a7)+,d0-d4/a0-a3
	rts

showworld:
	movem.l d0/a0-a1,-(a7)
	move.l #LCD_MEM,a0
	move.l lpointer,a1
	move.w #959,d0
showing:
	move.l (a1)+,(a0)+
	dbra.w d0,showing
	movem.l (a7)+,d0/a0-a1
	rts

box:
	movem.l d0-d6/a0-a2,-(a7)
	move.l #LCD_MEM,a1
	move.w #194,d0
_createbox:
	move.w #$FFFF,(a1)+
	dbra.w d0,_createbox
	move.w #0,-(a7)
	move.l a0,-(a7)
	move.w #2,-(a7)
	move.w #1,-(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7
	readkeyon
	jsr flib::idle_loop
	readkeyoff
	movem.l (a7)+,d0-d6/a0-a2
	rts

begingame:
	SetFont #2
	readkeyoff
	bsr createnewline
	move.w #100,d0
	move.w #30,d1
	clr.w d6
	clr.w d2
_LAB_001:
	add.w ppstep,d6
	bsr scrollworldup
	clr.w d4
	clr.w d5
	bsr shownumber
	add.w #1,d2
	cmp.w #50,d2
	bne _nextstep
	bsr createnewline
	clr.w d2
_nextstep:
	cmp.w #2,ppstep
	beq _nowaiting
	move.w #2000,d4
_waiting:
	dbra.w d4,_waiting
_nowaiting:
	bsr showworld
	movem.l d0-d6/a0-a2,-(a7)
	add.w #8,d0
	add.w #13,d1
	mulu.w #30,d1
	lsr.w #3,d0
	add.w d0,d1
	not.w d0
	and.w #7,d0
	move.l #LCD_MEM,a0
	btst.b d0,0(a0,d1.w)
	bne _iswall
	movem.l (a7)+,d0-d6/a0-a2
	cmp.w #110,d1
	bcc _nofastfall
	add.w #1,d1
	bra _nofastfall
_iswall:
	movem.l (a7)+,d0-d6/a0-a2
	sub.w #1,d1
_nofastfall:
	cmp.w #1,d1
	bls endgame
	movem.l d0-d5,-(a7)
	lea ball(PC),a0
	bsr putsprite
	movem.l (a7)+,d0-d5
	bsr getkey
	btst.b #7,keymatrix+6
	beq TestRight
	lea ptext(PC),a0
	bsr box
	readkeyoff
	bra _LAB_001
TestRight:
	btst.b #6,keymatrix
	beq TestLeft
	cmp.w #223,d0
	beq TestLeft
	add.w #1,d0
	bra TestESC
TestLeft:
	btst.b #4,keymatrix
	beq TestESC
	tst.w d0
	beq TestESC
	sub.w #1,d0
TestESC:
	btst.b #6,keymatrix+8
	beq _LAB_001
endgame:
	lea gameover(PC),a0
	bsr box
	move.w d6,d1
	bsr scanhiscore
	bsr showhiscore
	rts

_main:
	move.l #LCD_MEM,a0
	cmp.l #$4440,a0
; If this is changed to BNE then the program only runs on a TI92 I
	beq _isnt_TI92II
	readkeyon
	move.l #30*142,-(sp)
	jsr tios::HeapAlloc
	add.l #4,sp
	tst.w d0
	beq ende
	move.w d0,lhandle
	tios::DEREF d0,a6
	move.l a6,lpointer
	move.l a6,a0
	move.w #1049,d0
_clearbuffer:
	clr.l (a0)+
	dbra.w d0,_clearbuffer
	readkeyon
	move.w #$700,d0
	trap #1
	bclr.b #2,$600001
	move.l $64,oldint1
	move.l $64+5*4,oldint6
	move.l #autoint1,$64
	move.l #autoint6,$64+5*4
	bset.b #2,$600001
	trap #1
;	jsr gray4lib::on
;	tst.l d0
;	beq _afterpic
;	lea titlescreen(PC),a0
;	move.l gray4lib::plane0,a1
;	jsr hufflib::extract
;	lea titlescreen(PC),a0
;	move.l gray4lib::plane1,a1
;	jsr hufflib::extract
;	readkeyon
;	jsr flib::idle_loop
;	jsr gray4lib::off
;_afterpic:
	jsr flib::zap_screen
	SetFont #2
	WriteStr #1,#1,#4,_comment
	SetFont #1
_speednr:
	lea whatspeed2(PC),a0
	lea whatspeed1(PC),a1
	move.w #65,d0
	move.w #40,d1
	move.w #4,d2
	jsr mxmlib::menu
	cmp.w #4,d0
	bcc end_game
	cmp.w #1,d0
	bne _nkey
	move.w #1,ppstep
	bra starte_spiel
_nkey:
	cmp.w #2,d0
	bne _rhiscore
	move.w #2,ppstep
	bra starte_spiel
_rhiscore:
	lea hiscore(PC),a0
	move.w #4,d0
_resethiscore:
	move.l #757935360,(a0)+
	clr.w (a0)+
	clr.w (a0)+
	clr.w (a0)+
	dbra.w d0,_resethiscore
	bra _speednr
starte_spiel:
	jsr flib::zap_screen
	bsr begingame
end_game:
	move.w #$700,d0
	trap #1
	bclr.b #2,$600001
	move.l oldint1(PC),$64
	move.l oldint6(PC),$64+5*4
	bset.b #2,$600001
	trap #1
	move.w lhandle,-(sp)
	jsr tios::HeapFree
	add.l #2,sp
ende:
	rts
_isnt_TI92II:
	jsr flib::zap_screen
	SetFont #2
	WriteStr #0,#40,#4,wrongtiver1
	WriteStr #0,#50,#4,wrongtiver2
	WriteStr #0,#60,#4,wrongtiver3
	jsr flib::idle_loop
	rts

oldint1		dc.l 0
oldint6		dc.l 0
lhandle		dc.w 0
lpointer	dc.l 0
intflag		dc.w 0
vbl		dc.w 0
formatdec	dc.b "%u",0
formathiscore	dc.b "%8s %8u Points",0
output		dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
nwall		dc.w 0,0,0,0,0,0,0,0
ball		incbin "mxmfall.pic"
;titlescreen	incbin "mxmftit.huf"
hiscore		dc.b "---",0,0,0,0,0,0,0
		dc.b "---",0,0,0,0,0,0,0
		dc.b "---",0,0,0,0,0,0,0
		dc.b "---",0,0,0,0,0,0,0
		dc.b "---",0,0,0,0,0,0,0
number_sprites:
	dc.b %01111100
	dc.b %11000110
	dc.b %11000110
	dc.b %11010110
	dc.b %11000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

	dc.b %00011000
	dc.b %00111000
	dc.b %01111000
	dc.b %00011000
	dc.b %00011000
	dc.b %00011000
	dc.b %01111110
	dc.b %00000000

	dc.b %01111100
	dc.b %11000110
	dc.b %00000110
	dc.b %00111100
	dc.b %01100000
	dc.b %11000000
	dc.b %11111110
	dc.b %00000000

	dc.b %11111110
	dc.b %00000110
	dc.b %00001100
	dc.b %00111100
	dc.b %00000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

	dc.b %00011100
	dc.b %00111100
	dc.b %01101100
	dc.b %11001100
	dc.b %11111110
	dc.b %00001100
	dc.b %00001100
	dc.b %00000000

	dc.b %11111110
	dc.b %11000000
	dc.b %11000000
	dc.b %11111100
	dc.b %00000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

	dc.b %00111100
	dc.b %01100110
	dc.b %11000000
	dc.b %11111100
	dc.b %11000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

	dc.b %11111110
	dc.b %00000110
	dc.b %00001100
	dc.b %00011000
	dc.b %00110000
	dc.b %01100000
	dc.b %11000000
	dc.b %00000000

	dc.b %01111100
	dc.b %11000110
	dc.b %11000110
	dc.b %01111100
	dc.b %11000110
	dc.b %11000110
	dc.b %01111100
	dc.b %00000000

	dc.b %01111100
	dc.b %11000110
	dc.b %11000110
	dc.b %01111110
	dc.b %00000110
	dc.b %00001100
	dc.b %01111000
	dc.b %00000000
ppstep		dc.w 0
whatspeed1	dc.b "Select your speed",0
whatspeed2	dc.b " Speed  I           ",0,
		dc.b " Speed II           ",0,
		dc.b " R -> Reset HiScore ",0,
		dc.b " Exit               ",0
pressakey	dc.b "Press any key to continue",0
rhiscore	dc.b "You are in the HISCORE! Your Name?",0
tchi		dc.b "The current HISCORE:",0
ptext 		dc.b "Paused",0
gameover	dc.b "GAME OVER!",0
wrongtiver1	dc.b "This isn't a TI-92 II!",0
wrongtiver2	dc.b "Get the original FALLDOWN",0
wrongtiver3	dc.b "for your TI-92!",0
keymatrix	dc.b 0,0,0,0,0,0,0,0,0,0,0
ppstr		dc.b 0,0,0,0,0,0,0,0,0,0,0
ppstr2		dc.b 0,0,0,0,0,0,0,0,0,0,0
_comment	dc.b "MXM Falldown V1.5",0
	END
